#ifndef	_INCL_RTL8366_SMI_H
#define	_INCL_RTL8366_SMI_H

#define BOOL    unsigned char

#define	RTL8366S_MODEL_ID_REG	0x5C
#define	RTL8366S_REV_ID_REG		0x5D
#define	RTL8366S_MODEL_8366SR	0x6027
#define	RTL8366S_MODEL_8366RB	0x5937

extern	uint32_t smi_init(void);
extern	uint32_t smi_read(uint32_t mAddrs, uint32_t *rData);
extern	uint32_t smi_write(uint32_t mAddrs, uint32_t rData);

#if		defined(CFG_RTL8366SR_PHY) && defined(CFG_RTL8366RB_PHY)
//=======================================================
//	switch RTL8366SR or RTL8366RB functions
//=======================================================
#if	0
typedef	BOOL *(PFN_PHY_IS_UP)(int phyUnit);
typedef	int	 *(PFN_PHY_IS_FDX)(int unit);
typedef	int	 *(PFN_PHY_SPEED)(int unit);
typedef	BOOL *(PFN_PHY_SETUP)(int phyUnit);
typedef	struct	_rtl8366_funcs	{
	PFN_PHY_IS_UP	pfn_phy_is_up;
	PFN_PHY_IS_FDX	pfn_phy_is_fdx;
	PFN_PHY_SPEED	pfn_phy_speed;
	PFN_PHY_SETUP	pfn_phy_setup;
} RTL8366_FUNCS;

extern	uint32_t		g_rtl8366_chip_id;
extern	RTL8366_FUNCS	g_rtl8366_funcs;
#else
struct	_rtl8366_funcs	{
	BOOL		(*pfn_phy_is_up)(int phyUnit);
	int			(*pfn_phy_is_fdx)(int unit);
	int			(*pfn_phy_speed)(int unit);
	BOOL		(*pfn_phy_setup)(int unit);
};
extern	uint32_t				g_rtl8366_chip_id;
extern	struct _rtl8366_funcs	g_rtl8366_funcs;

#endif

extern	int	 rtl8366_chip_select(void);

#endif	//CFG_RTL8366SR and CFG_RTL8366RB

#endif	//_INCL_RTL8366_SMI_H
