#ifndef _AG7100_PHY_H
#define _AG7100_PHY_H

#ifndef	CONFIG_BUFFALO		//for Design
#error	"Need BUFFALO configuration"
#endif	//CONFIG_BUFFALO	//for Design

#ifdef CFG_ATHRS26_PHY

#define ag7100_phy_setup(unit) do { \
if(!unit) \
        athrs26_phy_setup(unit); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
if(!unit) \
        link=miiphy_link("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
if(!unit) \
        duplex = miiphy_duplex("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
if(!unit) \
        speed = miiphy_speed("eth0", CFG_PHY_ADDR); \
} while (0);

#endif

#ifdef CFG_VSC8201_PHY

#define ag7100_phy_setup(unit) do { \
if(!unit) \
        vsc_phy_setup(unit); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
if(!unit) \
        link=miiphy_link("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
if(!unit) \
        duplex = miiphy_duplex("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
if(!unit) \
        speed = miiphy_speed("eth0", CFG_PHY_ADDR); \
} while (0);

#endif

#ifdef CFG_VSC8601_PHY

#define ag7100_phy_setup(unit) do { \
if(!unit) \
        vsc8601_phy_setup(unit); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
if(!unit) \
        link=miiphy_link("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
if(!unit) \
        duplex = miiphy_duplex("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
if(!unit) \
        speed = miiphy_speed("eth0", CFG_PHY_ADDR); \
} while (0);

#endif

#ifdef CFG_VITESSE_8601_7395_PHY

#define ag7100_phy_setup(unit) do { \
if(unit) \
	vsc73xx_setup(unit); \
else \
	vsc8601_phy_setup(unit); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
if(unit) \
	vsc73xx_get_link_status(unit, &link, &fdx, &speed,0); \
else \
        link=miiphy_link("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
if(unit) \
	vsc73xx_get_link_status(unit, 0, &duplex, 0,0); \
else \
	duplex = miiphy_duplex("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
if(unit) \
	vsc73xx_get_link_status(unit, 0, 0, &speed,0); \
else \
	speed = miiphy_speed("eth0", CFG_PHY_ADDR); \
} while (0);

#endif


#ifdef CFG_IP175B_PHY

#define ag7100_phy_setup(unit) do { \
if(!unit) \
        ip_phySetup(unit); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
if(!unit) \
        link=ip_phyIsUp(unit); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
if(!unit) \
        duplex = ip_phyIsFullDuplex(unit); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
if(!unit) \
        speed = ip_phySpeed(unit); \
} while (0);

#endif

#ifdef CONFIG_ADMTEK_PHY

#define ag7100_phy_setup(unit) do { \
if(!unit) \
        miiphy_reset("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
if(!unit) \
        link=miiphy_link("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
if(!unit) \
        duplex = miiphy_duplex("eth0", CFG_PHY_ADDR); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
if(!unit) \
        speed = miiphy_speed("eth0", CFG_PHY_ADDR); \
} while (0);

#endif
#ifdef	CONFIG_BUFFALO		//for Design
#if		defined(CFG_RTL8366SR_PHY) && defined(CFG_RTL8366RB_PHY)
//		============================================
//			chip change RTL8366SR --> RTL8366RB
//		============================================
#include	"../../../board/ar7100/common/rtl8366_smi.h"

static void inline ag7100_phy_setup(int unit)
{
	//	init g_rtl8366_funcs
	rtl8366_chip_select();

	if (!unit) {
		if (g_rtl8366_funcs.pfn_phy_setup)	g_rtl8366_funcs.pfn_phy_setup(unit);
	}
}

#define ag7100_phy_link(unit,link,fdx,speed) do { \
	if (g_rtl8366_funcs.pfn_phy_is_up)	link = g_rtl8366_funcs.pfn_phy_is_up(unit);	\
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
	if (g_rtl8366_funcs.pfn_phy_is_up)	duplex = g_rtl8366_funcs.pfn_phy_is_fdx(unit);	\
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
	if (g_rtl8366_funcs.pfn_phy_speed)	speed = g_rtl8366_funcs.pfn_phy_speed(unit);	\
} while (0);


#elif	defined(CFG_RTL8366SR_PHY)
//		============================================
//			first revision board
//		============================================
#define ag7100_phy_setup(unit) do { \
if(!unit) \
        rtl8366sr_phy_setup(unit); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
		/*link=rtl8366sr_phy_is_link_alive(unit);*/ \
        link=rtl8366sr_phy_is_up(unit); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
        duplex = rtl8366sr_phy_is_fdx(unit); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
        speed = rtl8366sr_phy_speed(unit); \
} while (0);
#elif	defined(CFG_RTL8366RB_PHY)
//		============================================
//			debug for RTL8366RB
//		============================================
#define ag7100_phy_setup(unit) do { \
if(!unit) \
        rtl8366rb_phy_setup(unit); \
} while (0);

#define ag7100_phy_link(unit,link,fdx,speed) do { \
		/*link=rtl8366sr_phy_is_link_alive(unit);*/ \
        link=rtl8366rb_phy_is_up(unit); \
} while (0);

#define ag7100_phy_duplex(unit,duplex) do { \
        duplex = rtl8366rb_phy_is_fdx(unit); \
} while (0);

#define ag7100_phy_speed(unit,speed) do { \
        speed = rtl8366rb_phy_speed(unit); \
} while (0);
#endif	//RTL8366SR or RTL8366RB
#endif	//CONFIG_BUFFALO	//for Design
#endif /*_AG7100_PHY_H*/
