/*
 * This file contains the configuration parameters for the dbau1x00 board.
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#include <configs/ar7100.h>

//	ưɬ full-chip-reset Ԥ٤Υѥå(atheros) ͭˤ
#define	CONFIG_BUFFALO_WATCHDOG_CHIP_RESET



/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CFG_MAX_FLASH_BANKS     1	    /* max number of memory banks */
//#define CFG_MAX_FLASH_SECT      128    /* max number of sectors on one chip */
#define CFG_MAX_FLASH_SECT      256    /* max number of sectors on one chip */
#define CFG_FLASH_SECTOR_SIZE   (64*1024)
#define CFG_FLASH_SIZE          0x02000000 /* Total flash size */

#define CFG_FLASH_WORD_SIZE     unsigned short 
#define CFG_FLASH_ADDR0         (0x5555)  		
#define CFG_FLASH_ADDR1         (0x2AAA)

#define CFG_HOWL_1_2 1

#ifdef CFG_HOWL_1_2
#define AR9100_FLASH_CONFIG  0xb80f0004
#endif



/* 
 * We boot from this flash
 */
#define CFG_FLASH_BASE		    0xbe000000

#undef CONFIG_ROOTFS_RD
#undef CONFIG_ROOTFS_FLASH
#undef CONFIG_BOOTARGS_FL
#undef CONFIG_BOOTARGS_RD
#undef CONFIG_BOOTARGS
#undef  MTDPARTS_DEFAULT
#undef  MTDIDS_DEFAULT

//	SUPPORT LZMA
#define	CONFIG_LZMA			1
#define	BUFFALO_MEMTEST_ADVANCED	1
#define	BUFFALO_MEMTEST_EARLY		1

//	MEMORY ADDR DEFINE
#ifdef CONFIG_BUFFALO
#	define	XMK_STR(x)	#x
#	define	MK_STR(x)	XMK_STR(x)
#	define	XMK_HEX(x)	0x##x
#	define	MK_HEX(x)	XMK_HEX(x)
#	ifdef	CONFIG_WZR_HP_G300NH
#		define		BUFFALO_FW_SADDR		BE060000
#		define		BUFFALO_FW_EADDR		BFFDFFFF
#		define		BUFFALO_UBOOT_SADDR		BE000000
#		define		BUFFALO_UBOOT_EADDR		BE03FFFF
#		define		BUFFALO_TMP_RAM			81F00000
#		define		BUFFALO_TMP_BOTTOM		83F00000
//#		define		BUFFALO_MEMTEST_SADDR	00000000
//#		define		BUFFALO_MEMTEST_EADDR	03F00000
#	endif	//CONFIG_WZR_HP_G300NH
#	ifdef	CONFIG_DWR_HP_G300NH
#		define		BUFFALO_FW_SADDR		BE060000
#		define		BUFFALO_FW_EADDR		BFFDFFFF
#		define		BUFFALO_UBOOT_SADDR		BE000000
#		define		BUFFALO_UBOOT_EADDR		BE03FFFF
#		define		BUFFALO_TMP_RAM			81F00000
#		define		BUFFALO_TMP_BOTTOM		83F00000
//#		define		BUFFALO_MEMTEST_SADDR	00000000
//#		define		BUFFALO_MEMTEST_EADDR	03F00000
#	endif	//CONFIG_DWR_HP_G300NH

#endif	//CONFIG_BUFFALO

#define CONFIG_ROOTFS_FLASH
#define CONFIG_BOOTARGS CONFIG_BOOTARGS_FL

//#define CONFIG_BOOTARGS_RD     "console=ttyS0,115200 root=01:00 rd_start=0x80600000 rd_size=5242880 init=/sbin/init mtdparts=ar9100-nor0:256k(u-boot),64k(u-boot-env),4096k(rootfs),2048k(uImage)"
#define	CONFIG_BOOTARGS_RD		"console=ttyS0,115200 root=31:03 rootfstype=jffs2 init=/sbin/init mtdparts=ar9100-nor0:256k(u-boot),128k(u-boot-env),1024k(uImage),31104k(rootfs),128k@32640k(ART),128k@32512k(properties)"
/* XXX - putting rootfs in last partition results in jffs errors */

#ifndef CFG_HOWL_1_2
#define CONFIG_BOOTARGS_FL     "console=ttyS0,115200 root=31:00 rootfstype=jffs2 init=/sbin/init mtdparts=ar9100-nor0:4096k(rootfs),256k(u-boot),128k(u-boot-env),1024k(uImage)"
#else
#define CONFIG_BOOTARGS_FL     "console=ttyS0,115200 root=31:02 rootfstype=jffs2 init=/sbin/init mtdparts=ar9100-nor0:256k(u-boot),128k(u-boot-env),4096k(rootfs),1024k(uImage)"
#endif

#define MTDPARTS_DEFAULT    "mtdparts=ar9100-nor0:4096k(rootfs),256k(u-boot),128k(u-boot-env),1024k(uImage)"
#define MTDIDS_DEFAULT      "nor0=ar9100-nor0"


//#define CFG_FLASH_BASE		    0xbfc00000 /* Temp WAR as remap is not on by default */

/* 
 * The following #defines are needed to get flash environment right 
 */
#define	CFG_MONITOR_BASE	TEXT_BASE
#define	CFG_MONITOR_LEN		(192 << 10)

#undef CFG_HZ
/*
 * MIPS32 24K Processor Core Family Software User's Manual
 *
 * 6.2.9 Count Register (CP0 Register 9, Select 0)
 * The Count register acts as a timer, incrementing at a constant
 * rate, whether or not an instruction is executed, retired, or
 * any forward progress is made through the pipeline.  The counter
 * increments every other clock, if the DC bit in the Cause register
 * is 0.
 */
/* Since the count is incremented every other tick, divide by 2 */
/* XXX derive this from CFG_PLL_FREQ */
#if (CFG_PLL_FREQ == CFG_PLL_200_200_100)
#	define CFG_HZ          (200000000/2)
#elif (CFG_PLL_FREQ == CFG_PLL_300_300_150)
#	define CFG_HZ          (200000000/2)
#elif (CFG_PLL_FREQ == CFG_PLL_333_333_166)
#	define CFG_HZ          (333000000/2)
#elif (CFG_PLL_FREQ == CFG_PLL_266_266_133)
#	define CFG_HZ          (266000000/2)
#elif (CFG_PLL_FREQ == CFG_PLL_266_266_66)
#	define CFG_HZ          (266000000/2)
#elif (CFG_PLL_FREQ == CFG_PLL_400_400_200)
#	define CFG_HZ          (400000000/2)
#elif (CFG_PLL_FREQ == CFG_PLL_360_360_180)
#	define CFG_HZ          (360000000/2)
#endif


/* 
 * timeout values are in ticks 
 */
#define CFG_FLASH_ERASE_TOUT	(2 * CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(2 * CFG_HZ) /* Timeout for Flash Write */

/*
 * Cache lock for stack
 */
#define CFG_INIT_SP_OFFSET	0x1000

#define	CFG_ENV_IS_IN_FLASH    1
#undef CFG_ENV_IS_NOWHERE  

/* Address and size of Primary Environment Sector	*/
#define CFG_ENV_ADDR		0xbe040000
#define CFG_ENV_SIZE		0x20000

#define CONFIG_BOOTCOMMAND "bootm 0xbe060000"
//#define CONFIG_FLASH_16BIT

#define CONFIG_NR_DRAM_BANKS	2

#if (CFG_PLL_FREQ == CFG_PLL_200_200_100)
#define CFG_DDR_REFRESH_VAL     0x4c00
#define CFG_DDR_CONFIG_VAL      0x67bc8cd0
#define CFG_DDR_MODE_VAL_INIT   0x161
#define CFG_DDR_EXT_MODE_VAL    0x2
#define CFG_DDR_MODE_VAL        0x61
#elif (CFG_PLL_FREQ == CFG_PLL_400_400_200) || (CFG_PLL_FREQ == CFG_PLL_360_360_180)
//#define CFG_DDR_REFRESH_VAL     0x5f00
#define CFG_DDR_REFRESH_VAL     0x4c00
#define CFG_DDR_CONFIG_VAL      0x77bc8cd0
#define CFG_DDR_MODE_VAL_INIT   0x131
#define CFG_DDR_EXT_MODE_VAL    0x0
#define CFG_DDR_MODE_VAL        0x31
#endif

#define CFG_DDR_TRTW_VAL        0x1f
#define CFG_DDR_TWTR_VAL        0x1e

#define CFG_DDR_CONFIG2_VAL			    0x83d1f6a2
#define CFG_DDR_RD_DATA_THIS_CYCLE_VAL  0xffff


#define CONFIG_NET_MULTI

#define CONFIG_MEMSIZE_IN_BYTES


/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CONFIG_COMMANDS	(( CONFIG_CMD_DFL | CFG_CMD_DHCP | CFG_CMD_ELF | \
            CFG_CMD_MII | CFG_CMD_PING | CFG_CMD_NET | CFG_CMD_JFFS2 |\
   CFG_CMD_ENV | CFG_CMD_FLASH | CFG_CMD_LOADS | CFG_CMD_RUN | CFG_CMD_LOADB \
   | CFG_CMD_ELF ))


#define CONFIG_IPADDR		192.168.11.1
#define CONFIG_SERVERIP		192.168.11.2
#define CONFIG_ETHADDR		02:AA:BB:CC:DD:11
#define CFG_FAULT_ECHO_LINK_DOWN    1
#define CONFIG_PHY_GIGE       1              /* GbE speed/duplex detect */

//#define CFG_VSC8601_PHY
//#define CFG_VITESSE_8601_7395_PHY 1
#define CFG_RTL8366SR_PHY 1
#define CFG_RTL8366RB_PHY 1
#define CFG_AG7100_NMACS 2
#define CONFIG_AR9100 1

/*
 * Uncomment the #define given below for building u-boot
 * for DNI AP83 board with vitesse switch with no phy
 */
// #define CFG_VITESSE_73XX_NOPHY 1

//#define CFG_PHY_ADDR 0x14  /* Port 4 */
#define CFG_PHY_ADDR 0  /* Port 4 */
#define CFG_GMII     0
#define CFG_MII0_RGMII             1

#define CFG_BOOTM_LEN	(16 << 20) /* 16 MB */
#define DEBUG
#define CFG_HUSH_PARSER
#define CFG_PROMPT_HUSH_PS2 "hush>"

#include <cmd_confdefs.h>




/***************************************************************************/
#ifdef CONFIG_BUFFALO

/* : u_fw/u_ubootѿ̾¾ʤǤⶦ̤ǻѤ̾ΤΤᡢѹʤ */
#define	CONFIG_EXTRA_ENV_SETTINGS							\
	"tmp_ram=" MK_STR(BUFFALO_TMP_RAM) "\0"				\
	"tmp_bottom=" MK_STR(BUFFALO_TMP_BOTTOM) "\0"				\
	"fw_eaddr=" MK_STR(BUFFALO_FW_SADDR) " " MK_STR(BUFFALO_FW_EADDR) "\0"				\
	"uboot_eaddr=" MK_STR(BUFFALO_UBOOT_SADDR) " " MK_STR(BUFFALO_UBOOT_EADDR) "\0"				\
	"u_fw=erase $fw_eaddr; cp.b $fileaddr " MK_STR(BUFFALO_FW_SADDR) " $filesize; bootm " MK_STR(BUFFALO_FW_SADDR) ";\0"		\
	"ut_fw=tftp $tmp_ram firmware.bin; erase $fw_eaddr; cp.b $fileaddr " MK_STR(BUFFALO_FW_SADDR) " $filesize; bootm " MK_STR(BUFFALO_FW_SADDR) ";\0"	\
	"ut_uboot=tftp $tmp_ram u-boot.bin; protect off $uboot_eaddr; erase $uboot_eaddr; cp.b $fileaddr " MK_STR(BUFFALO_UBOOT_SADDR) " $filesize;\0"		\
	"melco_id=" BUFFALO_MELCO_ID "\0"	\
	"hw_rev=" BUFFALO_HW_REV "\0"		\
	"tftp_wait=4\0"						\
	CONFIG_EXTRA_ENV_SETTINGS_PRODUCT	\
	""


/*--------------------------------------------------*/
#ifdef	CONFIG_WZR_HP_G300NH
#undef	CONFIG_BOOTARGS
#define		CFG_EEPROM_ADDR			0xBFFE0000
#define		CFG_EEPROM_SIZE			0x20000
#define	CONFIG_BOOTARGS				"console=ttyS0,115200 root=31:03 rootfstype=jffs2 init=/sbin/init mtdparts=ar9100-nor0:256k(u-boot),128k(u-boot-env),1024k(uImage),31104k(rootfs),128k@32640k(ART),128k@32512k(properties)"
#define	CONFIG_EXTRA_ENV_SETTINGS_PRODUCT				\
	"uboot_ethaddr=02:AA:BB:CC:DD:11\0"					\
	"DEF-p_wireless_ath0_11bg-authmode=psk\0"			\
	"DEF-p_wireless_ath0_11bg-crypto=tkip+aes\0"		\
	"DEF-p_wireless_ath0_11bg-authmode_ex=mixed-psk\0"	\
	"DEF-p_wireless_ath0_11bg-wpapsk=1234567890123\0"	\
	"pincode=12345670\0"								\
	"custom_id=0\0"										\
	""
#endif	//CONFIG_WZR_HP_G300NH
/*--------------------------------------------------*/
#ifdef	CONFIG_DWR_HP_G300NH
#undef	CONFIG_BOOTARGS
#define		CFG_EEPROM_ADDR			0xBFFE0000
#define		CFG_EEPROM_SIZE			0x20000
#define	CONFIG_BOOTARGS				"console=ttyS0,115200 root=31:03 rootfstype=jffs2 init=/sbin/init mtdparts=ar9100-nor0:256k(u-boot),128k(u-boot-env),1024k(uImage),31104k(rootfs),128k@32640k(ART),128k@32512k(properties)"
#define	CONFIG_EXTRA_ENV_SETTINGS_PRODUCT				\
	"uboot_ethaddr=02:AA:BB:CC:DD:11\0"					\
	"DEF-p_wireless_ath0_11bg-authmode=psk\0"			\
	"DEF-p_wireless_ath0_11bg-crypto=tkip+aes\0"		\
	"DEF-p_wireless_ath0_11bg-authmode_ex=mixed-psk\0"	\
	"DEF-p_wireless_ath0_11bg-wpapsk=1234567890123\0"	\
	"pincode=12345670\0"								\
	"custom_id=0\0"										\
	""
#endif	//CONFIG_DWR_HP_G300NH





#define	CONFIG_STATUS_LED		1 /* enable status led driver */


/*--------------------------------------------------*/
#ifdef	CONFIG_WZR_HP_G300NH
#define	STATUS_LED_BITS			5

#define	STATUS_LED_BIT			(1 << 18)	/* LED[ROUTER] */
#define	STATUS_LED_STATE		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD		(CFG_HZ / 10)	/* ca. 1 Hz */
#define	STATUS_LED_PERIOD		1000
#define STATUS_LED_ACTIVE_LOW	1
#define	STATUS_LED_ROUTER		0		/* ROUTER LED */

#if	(STATUS_LED_BITS > 1)
#define	STATUS_LED_BIT1			(1 << 17)	/* LED[SECURITY_G] */
#define	STATUS_LED_STATE1		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD1		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD1		1000
#define STATUS_LED_ACTIVE_LOW1	1
#define	STATUS_LED_SECURITY		1		/* SECURITY G LED */
#endif

#if	(STATUS_LED_BITS > 2)
#define	STATUS_LED_BIT2			(1 << 1)	/* LED[DIAG] */
#define	STATUS_LED_STATE2		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD2		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD2		1000
#define STATUS_LED_ACTIVE_LOW2	1
#define	STATUS_LED_DIAG			2		/* fail LED */
#endif

#if	(STATUS_LED_BITS > 3)
#define	STATUS_LED_BIT3			(1 << 6)	/* LED[WIRELESS] */
#define	STATUS_LED_STATE3		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD2		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD3		1000
#define STATUS_LED_ACTIVE_LOW3	1
#define	STATUS_LED_WIRELESS		3		/* fail LED */
#endif

#if	(STATUS_LED_BITS > 4)
#define	STATUS_LED_BIT4			(1 << 0)	/* LED[USB] */
#define	STATUS_LED_STATE4		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD2		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD4		1000
#define STATUS_LED_ACTIVE_LOW4	1
#define	STATUS_LED_USB			4		/* fail LED */
#endif

#endif	//CONFIG_WZR_HP_G300NH
/*--------------------------------------------------*/
#ifdef	CONFIG_DWR_HP_G300NH
#define	STATUS_LED_BITS			5

#define	STATUS_LED_BIT			(1 << 18)	/* LED[ROUTER] */
#define	STATUS_LED_STATE		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD		(CFG_HZ / 10)	/* ca. 1 Hz */
#define	STATUS_LED_PERIOD		1000
#define STATUS_LED_ACTIVE_LOW	1
#define	STATUS_LED_ROUTER		0		/* ROUTER LED */

#if	(STATUS_LED_BITS > 1)
#define	STATUS_LED_BIT1			(1 << 17)	/* LED[SECURITY_G] */
#define	STATUS_LED_STATE1		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD1		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD1		1000
#define STATUS_LED_ACTIVE_LOW1	1
#define	STATUS_LED_SECURITY		1		/* SECURITY G LED */
#endif

#if	(STATUS_LED_BITS > 2)
#define	STATUS_LED_BIT2			(1 << 1)	/* LED[DIAG] */
#define	STATUS_LED_STATE2		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD2		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD2		1000
#define STATUS_LED_ACTIVE_LOW2	1
#define	STATUS_LED_DIAG			2		/* fail LED */
#endif

#if	(STATUS_LED_BITS > 3)
#define	STATUS_LED_BIT3			(1 << 6)	/* LED[WIRELESS] */
#define	STATUS_LED_STATE3		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD2		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD3		1000
#define STATUS_LED_ACTIVE_LOW3	1
#define	STATUS_LED_WIRELESS		3		/* fail LED */
#endif

#if	(STATUS_LED_BITS > 4)
#define	STATUS_LED_BIT4			(1 << 0)	/* LED[USB] */
#define	STATUS_LED_STATE4		STATUS_LED_OFF
//#define	STATUS_LED_PERIOD2		(CFG_HZ / 50)	/* ca. 5 Hz */
#define	STATUS_LED_PERIOD4		1000
#define STATUS_LED_ACTIVE_LOW4	1
#define	STATUS_LED_USB			4		/* fail LED */
#endif

#endif	//CONFIG_DWR_HP_G300NH


#define	STATUS_LED_PAR			1 /* makes status_led.h happy */
#define CONFIG_BOARD_SPECIFIC_LED

/*--------------------------------------------------*/
#endif	//CONFIG_BUFFALO

#endif	/* __CONFIG_H */
